## ros-noetic-dynamixel-workbench-toolbox 2.2.1

=== CMakeLists.txt ===
################################################################################
# Set minimum required version of cmake, project name and compile options
################################################################################
cmake_minimum_required(VERSION 3.0.2)
project(dynamixel_workbench_toolbox)

## Compile as C++11, supported in ROS Kinetic and newer
add_compile_options(-std=c++11)

################################################################################
# Find catkin packages and libraries for catkin and system dependencies
################################################################################
find_package(catkin REQUIRED COMPONENTS
  roscpp
  dynamixel_sdk
)

################################################################################
# Setup for python modules and scripts
################################################################################

################################################################################
# Declare ROS messages, services and actions
################################################################################

################################################################################
# Declare ROS dynamic reconfigure parameters
################################################################################

################################################################################
# Declare catkin specific configuration to be passed to dependent projects
################################################################################
catkin_package(
 INCLUDE_DIRS include
 LIBRARIES dynamixel_workbench_toolbox
 CATKIN_DEPENDS roscpp dynamixel_sdk
)

################################################################################
# Build
################################################################################
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

add_library(dynamixel_workbench_toolbox
  src/${PROJECT_NAME}/dynamixel_item.cpp
  src/${PROJECT_NAME}/dynamixel_driver.cpp
  src/${PROJECT_NAME}/dynamixel_tool.cpp
  src/${PROJECT_NAME}/dynamixel_workbench.cpp
)
add_dependencies(dynamixel_workbench_toolbox ${catkin_EXPORTED_TARGETS})
target_link_libraries(dynamixel_workbench_toolbox ${catkin_LIBRARIES})

################################################################################
# Install
################################################################################
install(TARGETS dynamixel_workbench_toolbox
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

################################################################################
# Test
################################################################################

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(dynamixel_workbench)

add_compile_options(-std=c++11)

include_directories(
  ../src
)

add_library(dynamixel_workbench
  ../src/dynamixel_workbench_toolbox/dynamixel_item.cpp
  ../src/dynamixel_workbench_toolbox/dynamixel_driver.cpp
  ../src/dynamixel_workbench_toolbox/dynamixel_tool.cpp
  ../src/dynamixel_workbench_toolbox/dynamixel_workbench.cpp
)

if(APPLE)
  target_link_libraries(dynamixel_workbench LINK_PUBLIC "/usr/local/lib/libdxl_mac_cpp.dylib")
else()
  target_link_libraries(dynamixel_workbench LINK_PUBLIC "/usr/local/lib/libdxl_x64_cpp.so")
endif()

add_executable(model_scan src/a_Model_Scan.cpp)
target_link_libraries(model_scan LINK_PUBLIC dynamixel_workbench)

add_executable(ping src/b_Ping.cpp)
target_link_libraries(ping LINK_PUBLIC dynamixel_workbench)

add_executable(id_change src/c_ID_Change.cpp)
target_link_libraries(id_change LINK_PUBLIC dynamixel_workbench)

add_executable(bps_change src/d_BPS_Change.cpp)
target_link_libraries(bps_change LINK_PUBLIC dynamixel_workbench)

add_executable(mode_change src/e_Mode_Change.cpp)
target_link_libraries(mode_change LINK_PUBLIC dynamixel_workbench)

add_executable(reboot src/f_Reboot.cpp)
target_link_libraries(reboot LINK_PUBLIC dynamixel_workbench)

add_executable(reset src/g_Reset.cpp)
target_link_libraries(reset LINK_PUBLIC dynamixel_workbench)

add_executable(position src/h_Position.cpp)
target_link_libraries(position LINK_PUBLIC dynamixel_workbench)

add_executable(velocity src/i_Velocity.cpp)
target_link_libraries(velocity LINK_PUBLIC dynamixel_workbench)

add_executable(current_based_position src/j_Current_Based_Position.cpp)
target_link_libraries(current_based_position LINK_PUBLIC dynamixel_workbench)

add_executable(read_write src/k_Read_Write.cpp)
target_link_libraries(read_write LINK_PUBLIC dynamixel_workbench)

add_executable(sync_write src/l_Sync_Write.cpp)
target_link_libraries(sync_write LINK_PUBLIC dynamixel_workbench)

add_executable(sync_read_write src/m_Sync_Read_Write.cpp)
target_link_libraries(sync_read_write LINK_PUBLIC dynamixel_workbench)

add_executable(bulk_read_write src/n_Bulk_Read_Write.cpp)
target_link_libraries(bulk_read_write LINK_PUBLIC dynamixel_workbench)

add_executable(find_dynamixel src/o_Find_Dynamixel.cpp)
target_link_libraries(find_dynamixel LINK_PUBLIC dynamixel_workbench)

add_executable(monitor src/p_Monitor.cpp)
target_link_libraries(monitor LINK_PUBLIC dynamixel_workbench)

=== debian/changelog ===
ros-noetic-dynamixel-workbench-toolbox (2.2.1-1focal) focal; urgency=high

  * Added 2XC430-W250, XL330 series
  * Contributors: Will Son, t-kitajima, Hye-jong KIM

 -- Will Son <willson@robotis.com>  Mon, 28 Jun 2021 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (2.2.0-1focal) focal; urgency=high

  * Added XW540
  * Bugs fixed, typos revised
  * Contributors: Ryan Shim, Yutaka Kondo, T-Kitajima, Nico Zevallos, Madhur Deep Jain, Will Son, YongHo Na

 -- Will Son <willson@robotis.com>  Thu, 24 Sep 2020 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (2.1.0-1focal) focal; urgency=high

  * Removed single_manager and single_manager_gui
  * Added XH540, PRO (A Firmware), RH_P12_RN, RH_P12_RN (A Firmware)
  * Contributors: Ryan Shim

 -- Will Son <willson@robotis.com>  Mon, 03 Jun 2019 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (2.0.0-1focal) focal; urgency=high

  * added YAML configuration for Dynamixel
  * supported position control mode, current based position control mode through Joint Trajectory Message
  * supported velocity control mode through Twist Message
  * reduced memory usage(Contribute by @KurtE)
  * updated API for sync, bulk instruction
  * updated control period (default is 10ms)
  * supported Linux, macos
  * supported Pro+
  * supported DynamixelSDK(after v.3.6.2)
  * supported OpenManipulator
  * Contributors: Darby Lim, KurtE, Pyo

 -- Will Son <willson@robotis.com>  Thu, 03 Jan 2019 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (1.0.0-1focal) focal; urgency=high

  * upgraded read time #162
  * added Dynamixel PRO information #162
  * added readRegister function
  * update dxl pro info
  * update proInfo func
  * modified max radian position
  * Contributors: Darby Lim, Pyo, Taehun Lim

 -- Will Son <willson@robotis.com>  Thu, 19 Jul 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.3.1-1focal) focal; urgency=high

  * None

 -- Will Son <willson@robotis.com>  Sun, 03 Jun 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.3.0-1focal) focal; urgency=high

  * added getProtocolVersion()
  * changed max_dxl_deries_num
  * merged pull request #152 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/152> #151 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/151> #149 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/149> #132 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/132>
  * Contributors: Darby Lim, Pyo

 -- Will Son <willson@robotis.com>  Thu, 31 May 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.2.4-1focal) focal; urgency=high

  * changed package.xml to format v2
  * Contributors: Pyo

 -- Will Son <willson@robotis.com>  Mon, 19 Mar 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.2.3-1focal) focal; urgency=high

  * None

 -- Will Son <willson@robotis.com>  Thu, 08 Mar 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.2.2-1focal) focal; urgency=high

  * modified the CI configurations (#117 <https://github.com/ROBOTIS-GIT/dynamixel-workbench/issues/117>)
  * modified the CMakeLists.txt to fix wrong path (ros/rosdistro#17019 <https://github.com/ros/rosdistro/pull/17019>)
  * Contributors: Pyo

 -- Will Son <willson@robotis.com>  Tue, 27 Feb 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.2.1-1focal) focal; urgency=high

  * modified the CMakeLists.txt to fix wrong path
  * Contributors: Pyo

 -- Will Son <willson@robotis.com>  Wed, 21 Feb 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.2.0-1focal) focal; urgency=high

  * added conver function to PRO user
  * added dxl_info_cnt init function
  * added compatibility for different protocol
  * added static
  * added convert function
  * added baudrate sorting
  * added all dynamixel series
  * added RX-10
  * added millis
  * added init dynamixel example
  * added setting for packet handler
  * added monitor example
  * added item
  * added dynamixel_item
  * added toolbox_ros and modified arduino path
  * added linux build and example
  * added begin and getprotocolversion function
  * modified linux version
  * modified description
  * modified model_info
  * modified variable range
  * modified setTools function
  * modified sync function
  * modified merge conflict
  * modified variable name
  * modified reset function
  * modified function name and return variable name
  * modified name of return var
  * modified item name
  * modified reset function
  * modified item name (added underscore)
  * modified function name
  * modified function for ROS depend
  * modified function to make space
  * modified begin function to reduce storage space
  * modified MX (2.0) protocol setting bug
  * modified example
  * modified sync and bulk comm
  * modified lib
  * modified begin
  * modified variable
  * modified begin function
  * modified joint and wheel mode
  * modified variable name
  * modified begin function
  * modified set function
  * modified dynamixel item
  * modified scan function
  * modified folder tree
  * modified dynamixel_tool
  * modified toolbox structure
  * modified .device and modified funtion for opencm and opencr
  * modified ifdef
  * modified get file
  * modified arduino version
  * modified get device in arduino
  * fixed reset bug
  * deleted dead code
  * deleted empty space
  * deleted xl define
  * deleted debug code and update ping func
  * test OpenCM
  * Contributors: Darby Lim, Yoonseok Pyo

 -- Will Son <willson@robotis.com>  Sun, 18 Feb 2018 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.1.9-1focal) focal; urgency=high

  * modified dependency
  * Contributors: Darby Lim

 -- Will Son <willson@robotis.com>  Thu, 02 Nov 2017 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.1.8-1focal) focal; urgency=high

  * None

 -- Will Son <willson@robotis.com>  Tue, 31 Oct 2017 15:00:00 -0000

ros-noetic-dynamixel-workbench-toolbox (0.1.7-1focal) focal; urgency=high



=== debian/control ===
Source: ros-noetic-dynamixel-workbench-toolbox
Section: misc
Priority: optional
Maintainer: Will Son <willson@robotis.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-dynamixel-sdk, ros-noetic-roscpp
Homepage: http://wiki.ros.org/dynamixel_workbench_toolbox
Standards-Version: 3.9.2

Package: ros-noetic-dynamixel-workbench-toolbox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-dynamixel-sdk, ros-noetic-roscpp
Description: This package is composed of 'dynamixel_item', 'dynamixel_tool', 'dynamixel_driver' and 'dynamixel_workbench' class.
 The 'dynamixel_item' is saved as control table item and information of Dynamixels. The 'dynamixel_tool' class loads its by model number of Dynamixels. The 'dynamixel_driver' class includes wraped function used in DYNAMIXEL SDK. The 'dynamixel_workbench' class make simple to use Dynamixels

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-dynamixel-workbench-toolbox//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
